/**
 * An exercise using a stack and a queue to determine whether a given string is a palindrome.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Palindrome
{
    private String testString;
    private boolean isPalindrome;
    
    public Palindrome()
    {
        testString = "";
        isPalindrome = true;
    }

    public Palindrome(String testStr)
    {
        testString = testStr;
        isPalindrome = false;
    }

    public boolean checkPalindrome()
    {
        boolean isPal = false;
        StackListBased stack = new StackListBased();
        QueueReferenceBased queue = new QueueReferenceBased();
        
        int strLen = testString.length();
        for (int i = 0; i < strLen; i++) {
            stack.push(new Character(testString.charAt(i)));
            queue.enqueue(new Character(testString.charAt(i)));
        }
        
        boolean mismatchFound = false;
        while (!stack.isEmpty() && !mismatchFound) {
            Character c1 = (Character)stack.pop();
            Character c2 = (Character)queue.dequeue();
            if (!c1.equals(c2)) mismatchFound = true;
        }
        
        if (!mismatchFound) isPal = true;
        return isPal;
    }

    public static void test()
    {
            String testStr1 = "abba";
            String testStr2 = "abc";
            String testStr3 = "";
        
            Palindrome p1 = new Palindrome(testStr1);
            Palindrome p2 = new Palindrome(testStr2);
            Palindrome p3 = new Palindrome(testStr3);
            
            if (p1.checkPalindrome())
                System.out.println(testStr1 + " is a palindrome");
            else System.out.println(testStr1 + " is not a palindrome");
            System.out.println("That should have printed that " + testStr1 + " is a palindrome");
            
            if (p2.checkPalindrome())
                System.out.println(testStr2 + " is a palindrome");
            else System.out.println(testStr2 + " is not a palindrome");
            System.out.println("That should have printed that " + testStr2 + " is not a palindrome");
            
             if (p3.checkPalindrome())
                System.out.println(testStr3 + "(empty string) is a palindrome");
            else System.out.println(testStr3 + "(empty string) is not a palindrome");
            System.out.println("That should have printed that " + testStr3 + "(empty string) is a palindrome");
    }
}
